require 'ISUI/ISEmoteRadialMenu'
local ISEmoteRadialMenu_fillMenu_old = ISEmoteRadialMenu.fillMenu

function split(str, sep)
    if sep == nil then sep = "%s" end
    local t = {}
    for str in string.gmatch(str, "([^"..sep.."]+)") do table.insert(t, str) end
    return t
end

local PoseZCards = {
	["AuthenticPoseZ.AD_Pose_Card_Action_1"] = "Action_1",
	["AuthenticPoseZ.AD_Pose_Card_Action_2"] = "Action_2",
	["AuthenticPoseZ.AD_Pose_Card_Action_3"] = "Action_3",
	["AuthenticPoseZ.AD_Pose_Card_Action_4"] = "Action_4",
	["AuthenticPoseZ.AD_Pose_Card_Action_5"] = "Action_5",
	["AuthenticPoseZ.AD_Pose_Card_Action_6"] = "Action_6",
	["AuthenticPoseZ.AD_Pose_Card_Action_7"] = "Action_7",
	["AuthenticPoseZ.AD_Pose_Card_BodyBuilding_1"] = "BodyBuildingPose1",
	["AuthenticPoseZ.AD_Pose_Card_BodyBuilding_2"] = "BodyBuildingPose2",
	["AuthenticPoseZ.AD_Pose_Card_BodyBuilding_3"] = "BodyBuildingPose3",
	["AuthenticPoseZ.AD_Pose_Card_BodyBuilding_4"] = "BodyBuildingPose4",
	["AuthenticPoseZ.AD_Pose_Card_BodyBuilding_5"] = "BodyBuildingPose5",
	["AuthenticPoseZ.AD_Pose_Card_Crouch_1"] = "Crouch_01",
	["AuthenticPoseZ.AD_Pose_Card_Crouch_2"] = "Crouch_02",
	["AuthenticPoseZ.AD_Pose_Card_Crouch_3"] = "Crouch_03",
	["AuthenticPoseZ.AD_Pose_Card_Crouch_4"] = "Crouch_04",
	["AuthenticPoseZ.AD_Pose_Card_Crouch_5"] = "Crouch_05",
	["AuthenticPoseZ.AD_Pose_Card_Crouch_6"] = "Crouch_06",
	["AuthenticPoseZ.AD_Pose_Card_Crouch_7"] = "Crouch_07",	
	["AuthenticPoseZ.AD_Pose_Card_Crouch_8"] = "Crouch_08",	
	["AuthenticPoseZ.AD_Pose_Card_Dab"] = "DabLoop",
	["AuthenticPoseZ.AD_Pose_Card_Dance_1"] = "PoseDance_1",
	["AuthenticPoseZ.AD_Pose_Card_Dance_2"] = "PoseDance_2",
	["AuthenticPoseZ.AD_Pose_Card_Dance_3"] = "PoseDance_3",
	["AuthenticPoseZ.AD_Pose_Card_Dance_4"] = "PoseDance_4",
	["AuthenticPoseZ.AD_Pose_Card_Dance_5"] = "PoseDance_5",
	["AuthenticPoseZ.AD_Pose_Card_Dance_6"] = "PoseDance_6",
	["AuthenticPoseZ.AD_Pose_Card_Dance_7"] = "PoseDance_7",
	["AuthenticPoseZ.AD_Pose_Card_Dynamic_1"] = "Dynamic_01",
	["AuthenticPoseZ.AD_Pose_Card_Dynamic_2"] = "Dynamic_02",
	["AuthenticPoseZ.AD_Pose_Card_Dynamic_3"] = "Dynamic_03",
	["AuthenticPoseZ.AD_Pose_Card_Dynamic_4"] = "Dynamic_04",
	["AuthenticPoseZ.AD_Pose_Card_Dynamic_5"] = "Dynamic_05",
	["AuthenticPoseZ.AD_Pose_Card_Dynamic_6"] = "Dynamic_06",
	["AuthenticPoseZ.AD_Pose_Card_Dynamic_7"] = "Dynamic_07",
	["AuthenticPoseZ.AD_Pose_Card_JumpingRope"] = "JumpingRope",
	["AuthenticPoseZ.AD_Pose_Card_Laying_1"] = "Laying_01",
	["AuthenticPoseZ.AD_Pose_Card_Laying_2"] = "Laying_02",
	["AuthenticPoseZ.AD_Pose_Card_Laying_3"] = "Laying_03",
	["AuthenticPoseZ.AD_Pose_Card_Laying_4"] = "Laying_04",
	["AuthenticPoseZ.AD_Pose_Card_Laying_5"] = "Laying_05",
	["AuthenticPoseZ.AD_Pose_Card_Laying_6"] = "Laying_06",
	["AuthenticPoseZ.AD_Pose_Card_Laying_7"] = "Laying_07",
	["AuthenticPoseZ.AD_Pose_Card_Laying_8"] = "Laying_08",
	["AuthenticPoseZ.AD_Pose_Card_Laying_9"] = "Laying_09",
	["AuthenticPoseZ.AD_Pose_Card_Laying_10"] = "Laying_10",
	["AuthenticPoseZ.AD_Pose_Card_Laying_11"] = "Laying_11",
	["AuthenticPoseZ.AD_Pose_Card_Laying_12"] = "Laying_12",
	["AuthenticPoseZ.AD_Pose_Card_Laying_13"] = "Laying_13",
	["AuthenticPoseZ.AD_Pose_Card_Locomotion_1"] = "Locomotion_01",
	["AuthenticPoseZ.AD_Pose_Card_Locomotion_2"] = "Locomotion_02",
	["AuthenticPoseZ.AD_Pose_Card_Locomotion_3"] = "Locomotion_03",
	["AuthenticPoseZ.AD_Pose_Card_Locomotion_4"] = "Locomotion_04",
	["AuthenticPoseZ.AD_Pose_Card_Locomotion_5"] = "Locomotion_05",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_1"] = "Sitting_01",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_2"] = "Sitting_02",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_3"] = "Sitting_03",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_4"] = "Sitting_04",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_5"] = "Sitting_05",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_6"] = "Sitting_06",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_7"] = "Sitting_07",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_8"] = "Sitting_08",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_9"] = "Sitting_09",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_10"] = "Sitting_10",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_11"] = "Sitting_11",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_12"] = "Sitting_12",
	["AuthenticPoseZ.AD_Pose_Card_Sitting_13"] = "Sitting_13",
	["AuthenticPoseZ.AD_Pose_Card_Standing_01"] = "Standing_01",
	["AuthenticPoseZ.AD_Pose_Card_Standing_02"] = "Standing_02",
	["AuthenticPoseZ.AD_Pose_Card_Standing_03"] = "Standing_03",
	["AuthenticPoseZ.AD_Pose_Card_Standing_04"] = "Standing_04",
	["AuthenticPoseZ.AD_Pose_Card_Standing_05"] = "Standing_05",
	["AuthenticPoseZ.AD_Pose_Card_Standing_06"] = "Standing_06",
	["AuthenticPoseZ.AD_Pose_Card_Standing_07"] = "Standing_07",
	["AuthenticPoseZ.AD_Pose_Card_Standing_08"] = "Standing_08",
	["AuthenticPoseZ.AD_Pose_Card_Standing_09"] = "Standing_09",
	["AuthenticPoseZ.AD_Pose_Card_Standing_10"] = "Standing_10",
	["AuthenticPoseZ.AD_Pose_Card_Standing_11"] = "Standing_11",
	["AuthenticPoseZ.AD_Pose_Card_Standing_12"] = "Standing_12",
	["AuthenticPoseZ.AD_Pose_Card_Standing_13"] = "Standing_13",
	["AuthenticPoseZ.AD_Pose_Card_Standing_14"] = "Standing_14",
	["AuthenticPoseZ.AD_Pose_Card_Standing_15"] = "Standing_15",
	["AuthenticPoseZ.AD_Pose_Card_Standing_16"] = "Standing_16",
	["AuthenticPoseZ.AD_Pose_Card_Standing_17"] = "Standing_17",
	["AuthenticPoseZ.AD_Pose_Card_Standing_18"] = "Standing_18",
	["AuthenticPoseZ.AD_Pose_Card_Standing_19"] = "Standing_19",
	["AuthenticPoseZ.AD_Pose_Card_Standing_20"] = "Standing_20",
	["AuthenticPoseZ.AD_Pose_Card_Standing_21"] = "Standing_21",
	["AuthenticPoseZ.AD_Pose_Card_Standing_22"] = "Standing_22",
	["AuthenticPoseZ.AD_Pose_Card_Standing_23"] = "Standing_23",
	["AuthenticPoseZ.AD_Pose_Card_Standing_24"] = "Standing_24",
	["AuthenticPoseZ.AD_Pose_Card_Standing_25"] = "Standing_25",
	["AuthenticPoseZ.AD_Pose_Card_Standing_26"] = "Standing_26",
	["AuthenticPoseZ.AD_Pose_Card_Standing_27"] = "Standing_27",
	["AuthenticPoseZ.AD_Pose_Card_Standing_28"] = "Standing_28",
	["AuthenticPoseZ.AD_Pose_Card_Standing_29"] = "Standing_29",
	["AuthenticPoseZ.AD_Pose_Card_TPose"] = "T-Pose",
	["AuthenticPoseZ.AD_Pose_Card_Yoga_1"] = "YogaWarrior2",
	["AuthenticPoseZ.AD_Pose_Card_Yoga_2"] = "YogaMeditate",
	["AuthenticPoseZ.AD_Pose_Card_Yoga_3"] = "YogaVrikshasana",
	["AuthenticPoseZ.AD_Special_Card_Dancing_01"] = "AfroDance",
	["AuthenticPoseZ.AD_Special_Card_Dancing_02"] = "Breakdance",
	["AuthenticPoseZ.AD_Special_Card_Dancing_03"] = "BreakdanceFlair",
	["AuthenticPoseZ.AD_Special_Card_Dancing_04"] = "CaliforniaGirls",
	["AuthenticPoseZ.AD_Special_Card_Dancing_05"] = "DanceFlossing",
	["AuthenticPoseZ.AD_Special_Card_Dancing_06"] = "GangnamStyle",
	["AuthenticPoseZ.AD_Special_Card_Dancing_07"] = "HipHopLocking",
	["AuthenticPoseZ.AD_Special_Card_Dancing_08"] = "LockingHipHopDance",
	["AuthenticPoseZ.AD_Special_Card_Dancing_09"] = "HypeDance",
	["AuthenticPoseZ.AD_Special_Card_Dancing_10"] = "AuthenticDanceTwerk",
	["AuthenticPoseZ.AD_Special_Card_Movement_01"] = "BackFlip",
	["AuthenticPoseZ.AD_Special_Card_Movement_02"] = "BigJump",
	["AuthenticPoseZ.AD_Special_Card_Movement_03"] = "CartWheel",
	["AuthenticPoseZ.AD_Special_Card_Movement_04"] = "CatWalk",
	["AuthenticPoseZ.AD_Special_Card_Movement_05"] = "HipHopFootwork",
	["AuthenticPoseZ.AD_Special_Card_Movement_06"] = "FrontFlip",
	["AuthenticPoseZ.AD_Special_Card_Movement_07"] = "JumpingJacksLoop",
	["AuthenticPoseZ.AD_Special_Card_Movement_08"] = "MoonWalk",
	["AuthenticPoseZ.AD_Special_Card_Movement_09"] = "RunFlip",
	["AuthenticPoseZ.AD_Special_Card_Movement_10"] = "RunJump",	
	["AuthenticPoseZ.AD_Special_Card_Movement_11"] = "Strutting",	
	["AuthenticPoseZ.AD_Special_Card_Taunt_01"] = "BeatChest",
	["AuthenticPoseZ.AD_Special_Card_Taunt_02"] = "BlowKiss",
	["AuthenticPoseZ.AD_Special_Card_Taunt_03"] = "BootySlap",
	["AuthenticPoseZ.AD_Special_Card_Taunt_04"] = "Cheering",
	["AuthenticPoseZ.AD_Special_Card_Taunt_05"] = "Convulsing",
	["AuthenticPoseZ.AD_Special_Card_Taunt_06"] = "CutThroat",
	["AuthenticPoseZ.AD_Special_Card_Taunt_07"] = "FlexMuscles",
	["AuthenticPoseZ.AD_Special_Card_Taunt_08"] = "Impatient",
	["AuthenticPoseZ.AD_Special_Card_Taunt_09"] = "TauntLoser",
	["AuthenticPoseZ.AD_Special_Card_Taunt_10"] = "Threaten",	
	["AuthenticPoseZ.AD_Special_Card_Taunt_11"] = "Yell",		
	
}

function ISEmoteRadialMenu:fillMenu(submenu)

	local allItems = self.character:getInventory():getItems()
	local APZ = false
	for i=1,allItems:size() do
		local item = allItems:get(i-1)
		if PoseZCards[item:getFullType()] then
			if not APZ then
				APZ = true
				ISEmoteRadialMenu.menu['APZ'] = {};
				ISEmoteRadialMenu.menu['APZ'].name = getText('IGUI_Emote_AuthenticPoseZ');
				ISEmoteRadialMenu.menu['APZ'].subMenu = {};	
				ISEmoteRadialMenu.icons['APZ'] = getTexture('media/ui/emotes/AuthenticPoseZ.png');
			end
			ISEmoteRadialMenu.menu['APZ'].subMenu[PoseZCards[item:getFullType()]] = getText('IGUI_Emote_' .. PoseZCards[item:getFullType()]);
			ISEmoteRadialMenu.icons[PoseZCards[item:getFullType()]] = getTexture('media/ui/emotes/' .. PoseZCards[item:getFullType()] .. '.png');
		end
	end
	ISEmoteRadialMenu_fillMenu_old(self, submenu)
end

function ISEmoteRadialMenu:emote(emote)
	
    -- Grab the last entry in the chain. (This is the emote)
    if string.find(emote, ';') ~= nil then
        local split = split(emote, ';');
        emote = split[#split];
    end

    -- check for variant of the same anim (like wave hi could be wavehi or wavehi02)
	if ISEmoteRadialMenu.variants[emote] then
		emote = ISEmoteRadialMenu.variants[emote][ZombRand(#ISEmoteRadialMenu.variants[emote])+1];
	end
	self.character:playEmote(emote);
	if emote == "shout" then
		self.character:Callout(false);
	end
end
